//+------------------------------------------------------------------+
//|                                 ConsecutiveHL AlertIndicator.mq4 |
//|                              based upon  Engulfing Bar Alert.mq4 |
//+------------------------------------------------------------------+
#property copyright "original: Copyright  unknown // mod. fxdaytrader, http://ForexBaron.net"
#property link "http://forexBaron.net"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Violet

extern int TimeFrame=0;
extern int ConsecutiveHLbars = 3;
extern int BarsLookBack = 500;

extern string ahi="******* ALERT SETTINGS:";
extern int    AlertCandle            = 0;//0:current, 1:last bar, etc.
extern bool   PopupAlerts            = true;
extern bool   EmailAlerts            = false;
extern bool   PushNotificationAlerts = false;
extern bool   SoundAlerts            = false;
extern string SoundFileLong          = "alert.wav";
extern string SoundFileShort         = "alert2.wav";
extern bool   ShowArrows             = true;//FALSE;
//---- buffers
double Up[],Dn[];
//+------------------------------------------------------------------+

int init()
  {
   TimeFrame=MathMax(TimeFrame,Period());
   SetIndexBuffer(0,Up);
   SetIndexBuffer(1,Dn);
   
   SetIndexLabel(0,"UP");
   SetIndexLabel(1,"DN");
   
   if (ShowArrows) {
    SetIndexStyle(0,DRAW_ARROW);
    SetIndexStyle(1,DRAW_ARROW);
   }
   else if (!ShowArrows) {
    SetIndexStyle(0,DRAW_NONE);
    SetIndexStyle(1,DRAW_NONE);
   }
      
   SetIndexArrow(0,233);
   SetIndexArrow(1,234);
   
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+

int start() {
   int i, counter;
   double Range, AvgRange;
   static datetime lastAlert = 0;
   //int CountBars=Bars;
   int CountBars=BarsLookBack;
   if (CountBars==0) CountBars=Bars;

   for(i=0; i<CountBars; i++)   
   {
      counter=i;
      Range=0;
      AvgRange=0;
      for (counter=i ;counter<=i+2;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
      

      if (IsConsecutiveHighBars(ConsecutiveHLbars,i)) {
       Up[i+1]=Low[i+1]-Range*1.5;
       if (i==AlertCandle) if (lastAlert!=Time[0]) { doAlerts("Got "+ConsecutiveHLbars+" consecutive HIGH bars",SoundFileLong); lastAlert=Time[0]; }
      }
      if (IsConsecutiveLowBars(ConsecutiveHLbars,i)) {
       Dn[i+1]=High[i+1]+Range*1.5;
       if (i==AlertCandle) if (lastAlert!=Time[0]) { doAlerts("Got "+ConsecutiveHLbars+" consecutive LOW bars",SoundFileShort); lastAlert=Time[0]; }
      }
      
   }
 return(0);
}


void doAlerts(string msg,string SoundFile) {
        msg="ConsecutiveHL Alert on "+Symbol()+", period "+TFtoStr(Period())+": "+msg;
 string emailsubject="MT4 alert on acc. "+AccountNumber()+", "+WindowExpertName()+" - Alert on "+Symbol()+", period "+TFtoStr(Period());
  if (PopupAlerts) Alert(msg);
  if (EmailAlerts) SendMail(emailsubject,msg);
  if (PushNotificationAlerts) SendNotification(msg);
  if (SoundAlerts) PlaySound(SoundFile);

}//void doAlerts(string msg,string SoundFile) {

string TFtoStr(int period) {
 switch(period) {
  case 1     : return("M1");  break;
  case 5     : return("M5");  break;
  case 15    : return("M15"); break;
  case 30    : return("M30"); break;
  case 60    : return("H1");  break;
  case 240   : return("H4");  break;
  case 1440  : return("D1");  break;
  case 10080 : return("W1");  break;
  case 43200 : return("MN1"); break;
  default    : return(DoubleToStr(period,0));
 }
 return("UNKNOWN");
}//string TFtoStr(int period) {

bool IsConsecutiveHighBars(int cbars,int cshift) {
 cshift = iBarShift(NULL,TimeFrame,Time[cshift]);
 for (int cnt=cshift; cnt<=cshift+cbars;cnt++) {    
  if (iClose(Symbol(),TimeFrame,cnt)<=iClose(Symbol(),TimeFrame,cnt+1)) return(false);
 }
 return(true);
}

bool IsConsecutiveLowBars(int cbars,int cshift) {
 cshift = iBarShift(NULL,TimeFrame,Time[cshift]);
 for (int cnt=cshift; cnt<=cshift+cbars;cnt++) {
  if (iClose(Symbol(),TimeFrame,cnt)>=iClose(Symbol(),TimeFrame,cnt+1)) return(false);
 }
 return(true);
}